﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Configuration;

namespace OccupationMonitorLib.DataAccess
{
    public static class Config
    {
        #region ErrorLogsConfiguration
        public static string OccServiceErrorLogPath { get { return ConfigurationManager.AppSettings["OccServiceErrorLogPath"].ToString(); } }
        public static string LoggerErrorLogPath { get { return ConfigurationManager.AppSettings["LoggerErrorLogPath"].ToString(); } }
        public static string EventLogSource { get { return ConfigurationManager.AppSettings["EventLogSource"].ToString(); } }
        #endregion

        #region OccupationImagesConfiguration
        public static string OccImagesPath  { get { return ConfigurationManager.AppSettings["OccImagesPath"]; }   }
        public static int OccPenSize { get { return Convert.ToInt32(ConfigurationManager.AppSettings["OccPenSize"]); } }
        public static int OccLegendHeight { get { return Convert.ToInt32(ConfigurationManager.AppSettings["OccLegendHeight"]); } }
        public static int PcBorderLength { get { return Convert.ToInt32(ConfigurationManager.AppSettings["PcBorderLength"]); } }
        public static int PcLength { get { return Convert.ToInt32(ConfigurationManager.AppSettings["PcLength"]); } }
        #endregion

        #region
        public static string OccCsvPath { get { return ConfigurationManager.AppSettings["OccCsvsPath"]; } }
        #endregion

        #region StatsImagesConfiguration
        public static int StatsImgWidth { get { return Convert.ToInt32(ConfigurationManager.AppSettings["StatsImgWidth"]); } }
        public static int StatsImgHeight {  get { return Convert.ToInt32(ConfigurationManager.AppSettings["StatsImgHeight"]); }  }
        public static int StatsPenSize { get { return Convert.ToInt32(ConfigurationManager.AppSettings["StatsPenSize"]); } }
        public static int StatsImgPadding { get { return Convert.ToInt32(ConfigurationManager.AppSettings["StatsImgPadding"]); } }
        public static int StatsAxisPartLength { get { return Convert.ToInt32(ConfigurationManager.AppSettings["StatsAxisPartLength"]); } }
        public static float StatsPartSizeCoefficient { get { return Convert.ToSingle(ConfigurationManager.AppSettings["StatsPartSizeCoefficient"], System.Globalization.CultureInfo.InvariantCulture); } }
        #endregion

        #region ConnectionsConfiguration
        public static string OracleConnString { get { return ConfigurationManager.ConnectionStrings["Oracle"].ConnectionString; } }
        public static string ServiceHostAddress { get { return ConfigurationManager.AppSettings["ServiceHostAddress"]; } }
        #endregion

        #region Intervals
        public static int TimerIntervalsMiliSecs { get { return Convert.ToInt32(ConfigurationManager.AppSettings["TimerIntervalsMiliSecs"]);}}
        public static int LocalitiesProcessingTimeoutSecs { get { return Convert.ToInt32(ConfigurationManager.AppSettings["LocalitiesProcessingTimeoutSecs"]); } }
        #endregion

    }
}
