﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Oracle.DataAccess.Client;
using System.Data;

namespace OccupationMonitorLib.DataAccess
{
    internal class ConnectionSingleton
    {
        private static ConnectionSingleton _instance = null;
        private OracleConnection _connection = null;

        private ConnectionSingleton() { }

        public string ConnectionString { get; set; }

        public static ConnectionSingleton Instance
        {
            get
            {
                if (_instance == null) _instance = new ConnectionSingleton();
                return _instance;
            }
        }

        internal OracleConnection Connection
        {
            get
            {
                try
                {
                    _connection = Reconnect();
                }
                catch (Exception)
                {
                    return Reconnect();
                }
                return _connection;
            }
        }

        private OracleConnection Reconnect()
        {
            if (_connection != null && (_connection.State == ConnectionState.Broken || _connection.State == ConnectionState.Closed))
            {
                _connection.Close();
                _connection.Dispose();
                _connection = null;
            }
            if (_connection == null)
            {
                _connection = new OracleConnection(ConnectionString);
                _connection.Open();
            }

            return _connection;
        }
    }
}
