﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OccupationMonitorLib.MiniZappa;

namespace OccupationMonitorLib.DataObjects
{
    //trieda reprezentuje stav pocitaca v urcitom case
    class LogItem
    {
        #region Public properties
        //id studovne
        public long RootId { get; set; }
        //id pocitaca
        public long PcId { get; set; }
        //cas
        public DateTime Time { get; set; }
        //stav
        public WorkstationStatusEnum State { get; set; }
        #endregion

        public LogItem() { }

        public LogItem(long root, long pc, DateTime time, WorkstationStatusEnum status) 
        {
            RootId = root;
            PcId = pc;
            Time = time;
            State = status;
        }

        public override bool Equals(object obj)
        {
            LogItem newItem = obj as LogItem;

            if (newItem == null) return false;

            if (this.RootId == newItem.RootId && this.PcId == newItem.PcId && this.Time == newItem.Time && this.State == newItem.State) return true;
            else return false;
        }

        public override int GetHashCode()
        {
            return RootId.GetHashCode() + PcId.GetHashCode() + Time.GetHashCode() + State.GetHashCode();
        }

        public override string ToString()
        {
            return "("+RootId+", "+PcId+", "+Time.ToString()+", "+State.ToString()+")";
        }
    
    }
}
