﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OccupationMonitorLib.DataObjects
{
    //trieda reprezentujuca interval prihlasenia
    public class OccupationInterval
    {
        #region Public properties
        //id miestnosti
        public long RoomId { get; private set; }
        //id pocitaca
        public long PcId { get; private set; }
        //cas prihlasenia
        public DateTime Login { get; private set; }
        //cas odhlasenia
        public DateTime Logout { get; private set; }
        #endregion

        public OccupationInterval(long roomId, long pcId, DateTime lIn, DateTime lOut)
        {
            RoomId = roomId;
            PcId = pcId;
            Login = lIn;
            Logout = lOut;
        }

        public override bool Equals(object obj)
        {
            OccupationInterval newInt = obj as OccupationInterval;

            if (newInt == null) return false;

            if (this.RoomId == newInt.RoomId && this.PcId == newInt.PcId && this.Login == newInt.Login && this.Logout == newInt.Logout) return true;
            else return false;


        }

        public override int GetHashCode()
        {
            return RoomId.GetHashCode() + PcId.GetHashCode() + Login.GetHashCode() +Logout.GetHashCode();
        }

        public override string ToString()
        {
            return "("+RoomId+", "+PcId+", "+Login.ToString()+", "+Logout.ToString()+")";
        }
    
    }
}
