﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Globalization;

namespace OccupationMonitorLib.DrawingStrategies
{
    class DrawXAxisWeek : DrawXAxisStrategy
    {
        //vykresli x-ovu os ktora reprezentuje dni v tyzdni
        internal override void DrawXAxis(Graphics g, Pen pen, float width, float height, int parts, int statsPadding, float partLength)
        {
            g.DrawLine(pen, statsPadding, height - pen.Width, width, height - pen.Width);
            float part = (width - statsPadding) / parts;
            for (int i = 0; i < parts + 1; i++)
            {
                g.DrawLine(pen, i * part + statsPadding, height - pen.Width, i * part + statsPadding, height - partLength - pen.Width);
                CultureInfo czechCulture = new CultureInfo("cs-CZ");
                DateTimeFormatInfo formatInfo = czechCulture.DateTimeFormat;

                if (i < parts) Draw(g, formatInfo.DayNames[(i+1)%7], (i) * part + statsPadding , height - pen.Width);
            }
        }

    }
}
