﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OccupationMonitorLib.DataObjects;

namespace OccupationMonitorLib.ProcessingStrategies
{
    class ProcessToMonths : ProcessingStrategy
    {
        internal override int MaxSeconds
        {
            get { return 2678400; }//31*24*60*60
        }

        //index prvku vo vratenom poli reprezentuje mesiac v roku
        internal override int[] Process(List<OccupationInterval> intervals)
        {
            int[] processed = new int[12];

            foreach (OccupationInterval interval in intervals)
            {
                if (ToSeconds(interval.Logout - interval.Login) < MaxLoginTime)//dlzka prihlasenia nesmie prekrocit 24 hodin
                {
                    if (interval.Login.Month == interval.Logout.Month) // prihlasenie a odlhasenie v 1 mesiaci
                    {
                        processed[interval.Login.Month - 1] += ToSeconds(interval.Logout - interval.Login);
                    }
                    else if ((interval.Login.Month + 1) % 12 == interval.Logout.Month) //prihlasenie a odhlasenie na prelome mesiacov
                    {
                        DateTime midnight = new DateTime(interval.Logout.Year, interval.Logout.Month, interval.Logout.Day, 0, 0, 0);
                        processed[interval.Login.Month - 1] += ToSeconds(midnight - interval.Login);
                        processed[interval.Logout.Month - 1] += ToSeconds(interval.Logout - midnight);
                    }
                }
            }
            return processed;
        }


    }
}
