﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OccupationMonitorLib.DataObjects;

namespace OccupationMonitorLib.ProcessingStrategies
{
    class ProcessToWeek : ProcessingStrategy
    {
        internal override int MaxSeconds
        {
            get { return 388800; }//4.5 * 24 * 60 * 60
        }

        //index prvku vo vratenom poli reprezentuje den v tyzdni
        internal override int[] Process(List<OccupationInterval> intervals)
        {
            int[] processed = new int[7];

            foreach (OccupationInterval interval in intervals)
            {
                if (ToSeconds(interval.Logout - interval.Login) < MaxLoginTime) //dlzka prihlasenia nesmie byt viac ako 24 hodin
                {
                    if (interval.Login.DayOfWeek == interval.Logout.DayOfWeek) // prihlasenie a odhlasenie v 1 den
                    {
                        processed[(int)interval.Login.DayOfWeek] += ToSeconds(interval.Logout - interval.Login);

                    }
                    else if (interval.Login.DayOfWeek + 1 == interval.Logout.DayOfWeek) // prihlasenie v 1 dni a odhlasenie pocas nasledujuceho dna
                    {
                        DateTime midnight = new DateTime(interval.Logout.Year, interval.Logout.Month, interval.Logout.Day, 0, 0, 0);

                        processed[(int)interval.Login.DayOfWeek] += ToSeconds(midnight - interval.Login);
                        processed[(int)interval.Logout.DayOfWeek] += ToSeconds(interval.Logout - midnight);

                    }
                }
            }
            //sunday ma v .NET index 0, preto treba pole posunut
            int sunday = processed[0];
            for (int i = 0; i < 6; i++) processed[i] = processed[i + 1];
            processed[6] = sunday;
            return processed;
        }
    }
}
