﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OccupationMonitorLib.DataObjects;

namespace OccupationMonitorLib.ProcessingStrategies
{
    //trieda zodpovedna za agregovanie casovych intervalov 
    abstract class ProcessingStrategy
    {
        //udava maximalny pocet pocitacosekund na jeden diel v statistike
        internal abstract int MaxSeconds { get; }

        // den v sekundach
        internal int MaxLoginTime { get { return 86400; } }  

        //metoda spracuvava casove intervaly a vracia ich v poli, ktoreho prvky reprezentuju pocet sekund pocas ktorych bol niekto prihlaseny v case. 
        //Cas je reprezentovany indexom prvku v poli. 
        internal abstract int[] Process(List<OccupationInterval> intervals);

        //konvertuje casovy interval formatu Timespan na odpovedajuci pocet sekund
        protected static int ToSeconds(TimeSpan toTransfer)
        {
            int result = 0;
            result += toTransfer.Seconds;
            result += toTransfer.Minutes*60;
            result += toTransfer.Hours * 60*60;
            result += toTransfer.Days * 24 * 60*60;

            return result;
        }
    }

    

    

    



}
