﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OccupationMonitorLib.MiniZappa;
using OccupationMonitorLib.DataObjects;

namespace OccupationMonitorLib.Processors
{
    //trieda zodpovedna za spracovanie jednohlivych zaznamov z databaze v tvare
    class IntervalsPreProcessors
    {
        //spracuvava zaznamy z databaze, transformuje ich na odpovedajuce intervaly prihlasenia
        //viz triedy LogItem a OccupationInterval
        //metoda predpoklada ze zoznam logov z databaze je usporiadany podla id pocitacov a casu! 
        internal List<OccupationInterval> ProcessLogs(List<LogItem> logItems, DateTime to) 
        {
            List<OccupationInterval> intervals = new List<OccupationInterval>();
            if (logItems.Count > 0)
            {
                for (int i = 1; i < logItems.Count ; i++) 
                {
                    //stav pocitaca sa zmeni z obsadeneho na nejaky iny - odhlasenie
                    if (logItems[i - 1].State == WorkstationStatusEnum.Occupied && logItems[i].State != WorkstationStatusEnum.Occupied && logItems[i-1].PcId == logItems[i].PcId) 
                    {
                        intervals.Add(new OccupationInterval(logItems[i].RootId, logItems[i].PcId, logItems[i - 1].Time, logItems[i].Time));
                    }
                    //pocitac je obsadeny, ale nevieme v akom case sa uvolnil, pretoze nasledujuci zaznam sa vztahuje na iny pocitac
                    //znamena to, ze do casu, za ktory chceme pocitat statistiky, sa PC urcite neuvolnil
                    //koniec casoveho intervalu, pocas ktoreho chceme pocitat statistiku, prehlasime za cas uvolnenia pc - skutocny cas nas v tomto pripade nezaujima
                    else if (logItems[i - 1].State == WorkstationStatusEnum.Occupied && logItems[i - 1].PcId != logItems[i].PcId) 
                    {
                        intervals.Add(new OccupationInterval(logItems[i-1].RootId, logItems[i-1].PcId, logItems[i - 1].Time, to));
                    }
                }
            }
            return intervals;
        }


    }
}
